/*
    gcommon
    copyright (c) 1998-2013 Kazuki Iwamoto http://www.maid.org/ iwm@maid.org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "gcommon.h"


/******************************************************************************
* Selections                                                                  *
******************************************************************************/
#ifndef USE_GTK_EMULATE
# if ! GTK_CHECK_VERSION(2,16,0)
GdkAtom
gtk_selection_data_get_selection (GtkSelectionData *selection_data)
{
  return selection_data ? selection_data->selection : 0;
}
# endif /* not GTK_CHECK_VERSION(2,16,0) */


# if ! GTK_CHECK_VERSION(2,14,0)
const guchar *
gtk_selection_data_get_data (GtkSelectionData *selection_data)
{
  return selection_data ? selection_data->data : NULL;
}


gint
gtk_selection_data_get_length (GtkSelectionData *selection_data)
{
  return selection_data ? selection_data->length : -1;
}


GdkAtom
gtk_selection_data_get_data_type (GtkSelectionData *selection_data)
{
  return selection_data ? selection_data->type : 0;
}


GdkDisplay *
gtk_selection_data_get_display (GtkSelectionData *selection_data)
{
  return selection_data ? selection_data->display : NULL;
}


gint
gtk_selection_data_get_format (GtkSelectionData *selection_data)
{
  return selection_data ? selection_data->format : 0;
}


GdkAtom
gtk_selection_data_get_target (GtkSelectionData *selection_data)
{
  return selection_data ? selection_data->target : 0;
}
# endif /* not GTK_CHECK_VERSION(2,1,0) */
#endif /* not USE_GTK_EMULATE */
